part of masamune_signin_twitter;

class TwitterSignInAdapter extends SNSSignInAdapter {
  const TwitterSignInAdapter({
    required this.twitterAPIKey,
    required this.twitterAPISecret,
    required this.urlSchemeId,
  });

  final String twitterAPIKey;
  final String twitterAPISecret;
  final String urlSchemeId;

  @override
  String get provider => "twitter";

  @override
  Future<void> signIn() {
    assert(
        twitterAPIKey.isNotEmpty &&
            twitterAPISecret.isNotEmpty &&
            urlSchemeId.isNotEmpty,
        "[twitterAPIKey], [twitterAPISecret] and [urlSchemeId] need to be specified.");
    TwitterAuth.initialize(
      twitterAPIKey: twitterAPIKey,
      twitterAPISecret: twitterAPISecret,
      urlSchemeId: urlSchemeId,
    );
    return TwitterAuth.signIn();
  }

  @override
  Future<void> signOut() {
    assert(
        twitterAPIKey.isNotEmpty &&
            twitterAPISecret.isNotEmpty &&
            urlSchemeId.isNotEmpty,
        "[twitterAPIKey], [twitterAPISecret] and [urlSchemeId] need to be specified.");
    TwitterAuth.initialize(
      twitterAPIKey: twitterAPIKey,
      twitterAPISecret: twitterAPISecret,
      urlSchemeId: urlSchemeId,
    );
    return TwitterAuth.signOut();
  }

  /// Run it the first time the app is launched.
  @override
  @mustCallSuper
  Future<void> onInit(BuildContext context) async {
    super.onInit(context);
    assert(
        twitterAPIKey.isNotEmpty &&
            twitterAPISecret.isNotEmpty &&
            urlSchemeId.isNotEmpty,
        "[twitterAPIKey], [twitterAPISecret] and [urlSchemeId] need to be specified.");
    TwitterAuth.initialize(
      twitterAPIKey: twitterAPIKey,
      twitterAPISecret: twitterAPISecret,
      urlSchemeId: urlSchemeId,
    );
  }
}
